"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RejectcuspayRawMapper = exports.RejectcuspayMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const entities_1 = require("../../domain/entities");
class RejectcuspayMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('payid', {
            key: 'payid',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('dacId', {
            key: 'dac_id',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { payid, dac_id, _id, ...rest } = mongoModel;
        return entities_1.Rejectcuspay.create(payid || 0, dac_id || '', _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.RejectcuspayMongoMapper = RejectcuspayMongoMapper;
class RejectcuspayRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { payid, dac_id, ...rest } = rawModel;
        return entities_1.Rejectcuspay.create(payid || 0, dac_id || '', undefined, rest);
    }
}
exports.RejectcuspayRawMapper = RejectcuspayRawMapper;
