"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContrConfigRawMapper = exports.UpdateconfigeRawMapper = exports.ContrConfigMongoMapper = exports.UpdateconfigeMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const aw_antelope_1 = require("@alien-worlds/aw-antelope");
const entities_1 = require("../../domain/entities");
class UpdateconfigeMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('newConfig', {
            key: 'new_config',
            mapper: (value) => new ContrConfigMongoMapper().fromEntity(value),
        });
        this.mappingFromEntity.set('dacId', {
            key: 'dac_id',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { new_config, dac_id, _id, ...rest } = mongoModel;
        return entities_1.Updateconfige.create(new_config ? new ContrConfigMongoMapper().toEntity(new_config) : entities_1.ContrConfig.getDefault(), dac_id || '', _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.UpdateconfigeMongoMapper = UpdateconfigeMongoMapper;
class ContrConfigMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('lockupasset', {
            key: 'lockupasset',
            mapper: (value) => new aw_antelope_1.ExtendedAssetMongoMapper().fromEntity(value),
        });
        this.mappingFromEntity.set('maxvotes', {
            key: 'maxvotes',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('numelected', {
            key: 'numelected',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('periodlength', {
            key: 'periodlength',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('shouldPayViaServiceProvider', {
            key: 'should_pay_via_service_provider',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('initialVoteQuorumPercent', {
            key: 'initial_vote_quorum_percent',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('tokenSupplyTheshold', {
            key: 'token_supply_theshold',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('voteQuorumPercent', {
            key: 'vote_quorum_percent',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('authThresholdHigh', {
            key: 'auth_threshold_high',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('authThresholdMid', {
            key: 'auth_threshold_mid',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('authThresholdLow', {
            key: 'auth_threshold_low',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('lockupReleaseTimeDelay', {
            key: 'lockup_release_time_delay',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('requestedPayMax', {
            key: 'requested_pay_max',
            mapper: (value) => new aw_antelope_1.ExtendedAssetMongoMapper().fromEntity(value),
        });
    }
    toEntity(mongoModel) {
        const { lockupasset, maxvotes, numelected, periodlength, should_pay_via_service_provider, initial_vote_quorum_percent, token_supply_theshold, vote_quorum_percent, auth_threshold_high, auth_threshold_mid, auth_threshold_low, lockup_release_time_delay, requested_pay_max, _id, ...rest } = mongoModel;
        return entities_1.ContrConfig.create(lockupasset ? new aw_antelope_1.ExtendedAssetMongoMapper().toEntity(lockupasset) : aw_antelope_1.ExtendedAsset.getDefault(), maxvotes || 0, numelected || 0, periodlength || 0, should_pay_via_service_provider || false, initial_vote_quorum_percent || 0, token_supply_theshold || 0, vote_quorum_percent || 0, auth_threshold_high || 0, auth_threshold_mid || 0, auth_threshold_low || 0, lockup_release_time_delay || 0, requested_pay_max ? new aw_antelope_1.ExtendedAssetMongoMapper().toEntity(requested_pay_max) : aw_antelope_1.ExtendedAsset.getDefault(), _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.ContrConfigMongoMapper = ContrConfigMongoMapper;
class UpdateconfigeRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { new_config, dac_id, ...rest } = rawModel;
        return entities_1.Updateconfige.create(new_config ? new ContrConfigRawMapper().toEntity(new_config) : entities_1.ContrConfig.getDefault(), dac_id || '', undefined, rest);
    }
}
exports.UpdateconfigeRawMapper = UpdateconfigeRawMapper;
class ContrConfigRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { lockupasset, maxvotes, numelected, periodlength, should_pay_via_service_provider, initial_vote_quorum_percent, token_supply_theshold, vote_quorum_percent, auth_threshold_high, auth_threshold_mid, auth_threshold_low, lockup_release_time_delay, requested_pay_max, ...rest } = rawModel;
        return entities_1.ContrConfig.create(lockupasset ? new aw_antelope_1.ExtendedAssetRawMapper().toEntity(lockupasset) : aw_antelope_1.ExtendedAsset.getDefault(), maxvotes || 0, numelected || 0, periodlength || 0, should_pay_via_service_provider || false, initial_vote_quorum_percent || 0, token_supply_theshold || 0, vote_quorum_percent || 0, auth_threshold_high || 0, auth_threshold_mid || 0, auth_threshold_low || 0, lockup_release_time_delay || 0, requested_pay_max ? new aw_antelope_1.ExtendedAssetRawMapper().toEntity(requested_pay_max) : aw_antelope_1.ExtendedAsset.getDefault(), undefined, rest);
    }
}
exports.ContrConfigRawMapper = ContrConfigRawMapper;
