"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PendingpayRawMapper = exports.PendingpayMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const aw_antelope_1 = require("@alien-worlds/aw-antelope");
const entities_1 = require("../../domain/entities");
class PendingpayMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('key', {
            key: 'key',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('receiver', {
            key: 'receiver',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('quantity', {
            key: 'quantity',
            mapper: (value) => new aw_antelope_1.ExtendedAssetMongoMapper().fromEntity(value),
        });
    }
    toEntity(mongoModel) {
        const { key, receiver, quantity, _id, ...rest } = mongoModel;
        return entities_1.Pendingpay.create(key || 0, receiver || '', quantity ? new aw_antelope_1.ExtendedAssetMongoMapper().toEntity(quantity) : aw_antelope_1.ExtendedAsset.getDefault(), _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.PendingpayMongoMapper = PendingpayMongoMapper;
class PendingpayRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { key, receiver, quantity, ...rest } = rawModel;
        return entities_1.Pendingpay.create(key || 0, receiver || '', quantity ? new aw_antelope_1.ExtendedAssetRawMapper().toEntity(quantity) : aw_antelope_1.ExtendedAsset.getDefault(), undefined, rest);
    }
}
exports.PendingpayRawMapper = PendingpayRawMapper;
